unit U_ClientForm;
{
Beispielprogram des Tutorials "Sockets mit WinAPI"
(c) Etienne Gasch 2007
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, U_clientThread, U_inputform, winsock;



type
  TClientForm = class(TForm)
    ConnectButton: TButton;
    DisconnectButton: TButton;
    CloseButton: TButton;
    MessageEdit: TEdit;
    SendEdit: TEdit;
    sendButton: TButton;
    Memo: TMemo;
    Shape: TShape;
    Label1: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ConnectButtonClick(Sender: TObject);
    procedure DisconnectButtonClick(Sender: TObject);
    procedure sendButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    constructor Create(Aowner:hwnd;nr:integer); reintroduce;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure gettext(var msg:TWMcopyData);message WM_Copydata;
    procedure getshape(var msg:Tmessage);message WMshape;
    procedure sendtext(var msg:Tmessage);message WMsendtext;
    procedure getInput(var msg:Tmessage);message WMinput;
    procedure getThreadhandle(var msg:Tmessage);message WMhandle;
  private
    { Private-Deklarationen }
    nummer:integer;
    owner:hwnd;
    threadhandle:hwnd;
    Thread:TClientThread;
    tosend:string;
    ip:string;
    port:integer;
  public
    { Public-Deklarationen }
  end;

implementation

{$R *.dfm}


constructor TClientForm.Create(Aowner:hwnd;nr:integer);
begin
  owner:=Aowner;
  nummer:=nr;
  inherited create(nil);
end;

procedure Tclientform.getshape(var msg:Tmessage);
begin
  if msg.wparam=0 then Shape.Brush.Color:=clred
                  else Shape.Brush.Color:=clgreen;
end;
procedure TClientForm.gettext(var msg:TWMcopyData);
var s:string;
begin
  setlength(s,msg.copydatastruct^.cbdata);
  move(msg.copydatastruct^.lpdata^,s[1],msg.copydatastruct^.cbdata);
  case msg.CopyDataStruct^.dwData  of
    0: memo.Lines.Add(s);
    1: messageedit.Text:=s;
    2: sendedit.text:=s;
  end;
end;
procedure Tclientform.sendtext(var msg:Tmessage);
begin
  if msg.LParam=length(tosend) then begin
    move(tosend[1],pointer(msg.wparam)^,msg.lparam);
    msg.result:=1;
  end else msg.result:=0;
  tosend:='';
end;

procedure TClientForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  postmessage(threadhandle,WM_close,0,0);
  postmessage(owner,TM_close,nummer,1);
end;

procedure TClientForm.FormCreate(Sender: TObject);
begin
  threadhandle:=0;
  tosend:='';
  ip:='127.0.0.1';
  port:=10001;
end;

procedure TClientForm.FormShow(Sender: TObject);
begin
  thread:=tclientthread.create(handle);
  Caption:=Caption+' #'+inttostr(nummer);
end;

procedure TClientForm.ConnectButtonClick(Sender: TObject);
begin
  postmessage(threadhandle,WMconnect,-1,-1);
end;

procedure Tclientform.getInput(var msg: TMessage);
var inputform:tinputform;
    res:integer;
begin
    inputform:=tinputform.Create(nil);
    try
      inputform.IP.Text:=ip;
      inputform.Port.text:=inttostr(port);
      res:=inputform.ShowModal;
      if res=mrok then begin
        port:=strtoint(inputform.Port.text);
        ip:=inputform.IP.text;
        postmessage(threadhandle,WMConnect,inet_addr(pchar(ip)),htons(port));
      end;
    finally
      inputform.Free;
    end;
end;

procedure TClientForm.DisconnectButtonClick(Sender: TObject);
begin
  postmessage(threadhandle,WMDisConnect,0,0);
end;

procedure TClientForm.sendButtonClick(Sender: TObject);
begin
  if tosend<>'' then exit;
  tosend:=sendedit.text;
  postmessage(threadhandle,WMSend,0,length(tosend));
end;

procedure TClientForm.CloseButtonClick(Sender: TObject);
begin
  close;
end;

procedure TClientform.getThreadhandle(var msg:Tmessage);
begin
  threadhandle:=msg.WParam;
end;

end.
