unit U_Clientthread;
{
Beispielprogram des Tutorials "Sockets mit WinAPI"
(c) Etienne Gasch 2007
}
interface

uses
  Classes, winsock, windows, messages,  sysutils, graphics,
   controls;

const FD_All=FD_accept or FD_Close or FD_Read or FD_Write or FD_oob or FD_connect;
      TM_close=WM_User+10;
const WMConnect=WM_user+1;
      WMDisconnect=WM_User+2;
      WMsend=WM_User+3;
      WMsendtext=WM_user+4;
      WMShape=WM_User+6;
      WMInput=WM_user+7;
      WMHandle=WM_user+8;

type
  TClientThread = class(TThread)
    constructor create(aOwner:hwnd);
  private
    { Private-Deklarationen }
    ClientSocket:integer;
    owner:hwnd;

    procedure wndproc(var msg:Tmessage);
    procedure run;

    procedure connect(ip,port:integer);
    procedure disconnect;
    procedure send(s:string);

    procedure aktshape;
    procedure afterconnect;

    procedure sendtext(text:string;param:integer);

  protected
    procedure Execute; override;

  public
    handle:hwnd;
  end;

implementation


constructor TClientThread.create(AOwner:hwnd);
begin
  inherited create(true);
  freeonterminate:=true;
  owner:=aowner;
  resume;
end;
procedure TClientThread.afterconnect;
var h:Phostent;
    l:integer;
    laddr,raddr:sockaddr_in;
    addr:^PInAddr;
    addr_s:string;
begin
  if clientsocket=0 then exit;
  l:=sizeof(laddr);
  getsockname(clientsocket,laddr,l);
  getpeername(clientsocket,raddr,l);
  h:=gethostbyname(nil);
  Addr:=Pointer(h^.h_addr_list);
  if (Addr<>nil) AND (Addr^<>nil) then addr_s:=(inet_ntoa(Addr^^));
  sendtext('Connection Parameters',0);
  sendtext('  RemoteIP: '+inet_ntoa(raddr.sin_addr),0);
  sendtext('  RemotePort: '+inttostr(ntohs(raddr.sin_port)),0);
  sendtext('  SocketIP (connect to): '+inet_ntoa(laddr.sin_addr),0);
  sendtext('  LocalIP: '+addr_s,0);
  sendtext('  LocalPort: '+inttostr(ntohs(laddr.sin_port)),0);
  sendtext('  LocalHost: '+h^.h_name,0);
end;
procedure TclientThread.aktshape;
begin
  postmessage(owner,wmshape,clientsocket,0);
end;
procedure TClientThread.sendtext(text:string;param:integer);
var ds:TcopyDataStruct;
begin
  ds.dwData:=param;
  ds.lpData:=@text[1];
  ds.cbData:=length(text);
  sendmessage(owner,WM_copyData,handle,integer(@ds));
end;

procedure TClientthread.run;
var msg:Tmsg;
begin
  while (getmessage(msg,0,0,0))and(not terminated) do begin
    translatemessage(msg);
    dispatchmessage(msg);
  end;
end;
procedure TClientThread.disconnect;
begin
  if Clientsocket<>0 then begin
    if closesocket(clientsocket)<>socket_error then sendtext('disconnected',1)
      else sendtext('Fehler beim Verbindung trennen',1);
    clientsocket:=0;
  end;
  aktshape;
end;
procedure TClientThread.send(s:string);
begin
  if winsock.send(clientsocket,s[1],length(s),0)<>socket_error then
    sendtext('Message sent',1)
  else
    sendtext('Fehler beim Senden',1);
end;
procedure TClientThread.connect;
var addr:sockaddr_in;
begin
  if ClientSocket<>0 then exit;
  Clientsocket:=socket(af_inet,SOCK_STREAM,IPPROTO_TCP);
  if ClientSocket<>Invalid_socket then begin
      addr.sin_family:=af_inet;
      addr.sin_port:=port;
      addr.sin_addr.S_addr:=ip;
      if winsock.connect(clientsocket,addr,sizeof(addr))<>socket_error then begin
        if wsaasyncselect(Clientsocket,handle,wm_user,FD_all)<>socket_error then begin
          sendtext('Verbunden',1);
        end else begin
          sendtext('Fehler beim Initialisieren des Events',1);
          closesocket(clientsocket);
          clientsocket:=0;
        end;
      end else begin
        sendtext('can''t connect',1);
        closesocket(clientsocket);
        clientsocket:=0;
      end;
  end else begin
    clientsocket:=0;
    sendtext('Fehler bei Socketinitialisierung',1);
  end;
  aktshape;
  afterconnect;
end;
procedure TClientThread.Execute;
begin
  handle:=allocatehwnd(wndproc);
  postmessage(owner,wmhandle,handle,0);
  aktshape;
  ClientSocket:=0;
  run;
  postmessage(owner,WM_close,0,0);
  deallocatehwnd(handle);
end;
procedure TclientThread.wndproc(var msg:Tmessage);
var s:array[0..30] of char;
    tmp:string;
begin
  msg.result:=0;
  case msg.Msg of
    WM_user:begin
      sendtext('ClientSocket - Action:  $'+inttohex(msg.LParamlo,4),0);
      case msg.LParamLo of
        FD_Read:begin
          fillchar(s,length(s),0);
          recv(ClientSocket,s,length(s),0);
          sendtext('--> Read: '+s,0);
        end;
        FD_close : begin
          winsock.closesocket(ClientSocket);
          ClientSocket:=0;
          sendtext('--> Closed',0);
          aktshape;
        end;
        FD_connect : begin
          sendtext('--> Connected',0);
        end;
        FD_Write : begin
          sendtext('--> Write',0);
        end;
        else sendtext('--> Unknown ',0);
      end;
    end;
    WMConnect:if msg.LParam=-1 then begin
      if clientsocket=0 then postmessage(owner,wminput,0,0);
    end else begin
      connect(msg.WParam,msg.LParam);
    end;
    WMDisconnect:Disconnect;
    WMsend:begin
      setlength(tmp,msg.LParam);
      sendmessage(owner,wmsendtext,integer(@tmp[1]),msg.lparam);
      send(tmp);
    end;
    WM_Close:begin
      Disconnect;
      msg.result:=defwindowproc(handle,msg.Msg,msg.wparam,msg.lparam);
    end;
    WM_Destroy:PostQuitMessage(0);
    else msg.result:=defwindowproc(handle,msg.Msg,msg.wparam,msg.lparam);
  end;
end;

end.
