unit U_ServerForm;
{
Beispielprogram des Tutorials "Sockets mit WinAPI"
(c) Etienne Gasch 2007
}
interface


uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, U_Inputform, U_ServerThread, winsock;

const WMInitSocket=WM_user+1;
      WMCloseSocket=WM_user+2;
      WMSend=WM_User+3;
      TM_close=WM_user+10;

type
  TServerForm = class(TForm)
    InitButton: TButton;
    CloseSocketButton: TButton;
    closeButton: TButton;
    MessageEdit: TEdit;
    SendEdit: TEdit;
    sendButton: TButton;
    Memo: TMemo;
    Shape: TShape;
    ClientNr: TStaticText;
    Label1: TLabel;
    Label2: TLabel;
    procedure InitButtonClick(Sender: TObject);
    procedure CloseSocketButtonClick(Sender: TObject);
    procedure closeButtonClick(Sender: TObject);
    procedure sendButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    constructor create(aowner:hwnd;nr:integer); reintroduce;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
    tosend:string;
    ip:string;
    port:integer;
    thread:Tserverthread;
    threadhandle:hwnd;
    owner:hwnd;
    nummer:integer;
    procedure aktshape(var msg:Tmessage);message wmshape;
    procedure gettext(var msg:TWMcopyData);message wm_copydata;
    procedure sendtext(var msg:Tmessage);message wmsendtext;
    procedure getInput(var msg: TMessage);message WMInput;
    procedure getThreadhandle(var msg:Tmessage);message WMhandle;
  public
    { Public-Deklarationen }
  end;

implementation

{$R *.dfm}

constructor TServerform.create(aowner: HWND;nr:integer);
begin
  owner:=aowner;
  nummer:=nr;
  inherited create(nil);
end;

procedure TServerform.aktshape(var msg:Tmessage);
begin
 if msg.wparam=0 then Shape.Brush.Color:=clred
                 else Shape.Brush.Color:=clgreen;
 ClientNr.Caption:=inttostr(msg.lparam);
end;
procedure TServerForm.gettext(var msg:TWMcopyData);
var s:string;
begin
  setlength(s,msg.copydatastruct^.cbdata);
  move(msg.copydatastruct^.lpdata^,s[1],msg.copydatastruct^.cbdata);
  case msg.CopyDataStruct^.dwData  of
    0: memo.Lines.Add(s);
    1: messageedit.Text:=s;
    2: sendedit.text:=s;
  end;
end;
procedure Tserverform.sendtext(var msg:Tmessage);
begin
  if msg.LParam=length(tosend) then begin
    move(tosend[1],pointer(msg.wparam)^,msg.lparam);
    msg.result:=1;
  end else msg.result:=0;
  tosend:='';
end;

procedure TServerForm.InitButtonClick(Sender: TObject);
begin
  postmessage(threadhandle,wminitsocket,-1,-1);
end;

procedure TServerForm.CloseSocketButtonClick(Sender: TObject);
begin
  postmessage(threadhandle,wmclosesocket,0,0);
end;

procedure TServerForm.closeButtonClick(Sender: TObject);
begin
  close;
end;

procedure TServerForm.sendButtonClick(Sender: TObject);
begin
  if tosend<>'' then exit;
  tosend:=sendedit.Text;
  postmessage(threadhandle,wmsend,0,length(tosend));
end;

procedure TServerForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  postmessage(threadhandle,WM_close,0,0);
  postmessage(owner,TM_close,nummer,0);
end;

procedure TServerForm.FormCreate(Sender: TObject);
begin
  ip:='0.0.0.0';
  port:=10001;
  threadhandle:=0;
  tosend:='';
end;

procedure TServerForm.FormShow(Sender: TObject);
begin
  thread:=TServerthread.create(handle);
  caption:=caption+' #'+inttostr(nummer);
end;

procedure Tserverform.getInput(var msg: TMessage);
var inputform:tinputform;
    res:integer;
begin
    inputform:=tinputform.Create(nil);
    try
      inputform.IP.Text:=ip;
      inputform.Port.text:=inttostr(port);
      res:=inputform.ShowModal;
      if res=mrok then begin
        port:=strtoint(inputform.Port.text);
        ip:=inputform.IP.text;
        postmessage(threadhandle,WMinitsocket,inet_addr(pchar(ip)),htons(port));
      end;
    finally
      inputform.Free;
    end;
end;
procedure TServerform.getThreadhandle(var msg:Tmessage);
begin
  threadhandle:=msg.WParam;
end;

end.
