unit U_ServerThread;
{
Beispielprogram des Tutorials "Sockets mit WinAPI"
(c) Etienne Gasch 2007
}
interface

uses
  Classes, windows, messages, winsock, sysutils, graphics,
  controls;

const FD_All=FD_accept or FD_Close or FD_Read or FD_Write or FD_OOB or FD_connect;
const WMInitSocket=WM_user+1;
      WMCloseSocket=WM_user+2;
      WMSend=WM_User+3;
      WMshape=WM_User+4;
      WMsendtext=wm_user+5;
      WMinput=WM_user+6;
      WMhandle=WM_user+7;


type
  TServerthread = class(TThread)
    constructor create(AOwner:hwnd);
  private
    { Private-Deklarationen }
    acceptSocket:integer;
    connectsocket:array of integer;
    owner:hwnd;

    procedure run;
    procedure wndproc(var msg:Tmessage);

    procedure initsocket(ip,port:integer);
    procedure closesocket;
    procedure send(s:string);

    procedure aktshape;

    procedure insertsocket(aSocket:integer);
    procedure deletesocket(asocket:integer);
    function IsconnectSocket(asocket:integer):boolean;
    function socketCount:integer;

    procedure afterconnect(nr:integer);
    procedure afterinit;

    procedure sendtext(text:string;param:integer);

  protected
    procedure Execute; override;

  public
    handle:hwnd;
  end;

implementation


constructor TServerThread.create(AOwner:hwnd);
begin
  inherited create(true);
  freeonterminate:=true;
  owner:=aowner;
  resume;
end;

procedure TServerThread.aktshape;
begin
  postmessage(owner,wmshape,acceptsocket,socketcount);
end;
procedure TserverThread.sendtext(text:string;param:integer);
var ds:TcopyDataStruct;
begin
  ds.dwData:=param;
  ds.lpData:=@text[1];
  ds.cbData:=length(text);
  sendmessage(owner,WM_copyData,handle,integer(@ds));
end;

procedure TServerThread.wndproc(var msg:Tmessage);
var s:array[0..30] of char;
    addr:sockaddr_in;
    l:integer;
    nconnectSocket:integer;
    tmp:string;
begin
  msg.Result:=0;
  case msg.Msg of
    WM_user: begin
      if msg.wparam=acceptSocket then begin
        sendtext('AcceptSocket: (Action: $'+inttohex(msg.LParamlo,4)+')',0);
        case msg.LParam of
          FD_Accept: begin
            l:=sizeof(addr);
            nConnectSocket:=accept(acceptSocket,@addr,@l);
            if nConnectSocket=socket_error then sendtext('Fehler Accept',0)
            else begin
              insertsocket(nConnectsocket);
              sendtext('--> Connect from: '+
                inet_ntoa(addr.sin_addr)+':'+ inttostr(ntohs(addr.sin_port)),0);
            end;
            aktshape;
          end;
          else sendtext('--> Unknown',0);
        end;
      end else if IsConnectsocket(msg.WParam) then begin
        sendtext('ConnectSocket -  Handle: $'+inttostr(msg.wparam)+'; Action: $'+inttohex(msg.LParamlo,4),0);
        case msg.LParamLo of
          FD_Read:begin
            fillchar(s,length(s),0);
            recv(msg.wparam,s,length(s),0);
            sendtext('--> Read: '+s,0);
          end;
          FD_close : begin
            nconnectsocket:=msg.wparam;
            winsock.closesocket(nConnectSocket);
            deletesocket(nconnectsocket);
            sendtext('--> Closed',0);
            aktshape;
          end;
          FD_connect : begin
            sendtext('--> Connected',0);
          end;
          FD_Write : begin
            sendtext('--> Write',0);
          end;
          else sendtext('--> Unknown ',0);
        end;
      end else sendtext('Unkwnon socket',0);
    end;
    WMinitsocket: if msg.LParam=-1 then begin
      if acceptsocket=0 then postmessage(owner,wminput,0,0);
    end else begin
      initsocket(msg.WParam,msg.LParam);
    end;
    WMcloseSocket: closesocket;
    WMSend: begin
      setlength(tmp,msg.LParam);
      sendmessage(owner,wmsendtext,integer(@tmp[1]),msg.lparam);
      send(tmp);
    end;
    WM_Close:begin
      closesocket;
      msg.result:=defwindowproc(handle,msg.Msg,msg.WParam,msg.LParam);
    end;
    WM_destroy: Postquitmessage(0);
    else msg.result:=defwindowproc(handle,msg.Msg,msg.WParam,msg.LParam);
  end;
end;
procedure TServerThread.run;
var msg:tmsg;
begin
  while (getmessage(msg,0,0,0))and(not terminated) do begin
    translatemessage(msg);
    dispatchmessage(msg);
  end;
end;
procedure TServerThread.closeSocket;
var i:integer;
begin
  for i:=low(connectsocket) to high(connectsocket) do begin
    if connectsocket[i]<>0 then begin
      if winsock.closesocket(connectsocket[i])<>socket_error then sendtext('disconnected',1)
        else sendtext('Fehler beim Verbindung trennen',1);
      connectsocket[i]:=0;
    end;
  end;
  setlength(connectsocket,0);
  if Acceptsocket<>0 then begin
    if winsock.closesocket(Acceptsocket)<>socket_error then sendtext('disconnected',1)
      else sendtext('Fehler beim Verbindung trennen',1);
    Acceptsocket:=0;
  end;
  aktshape;
end;
procedure TServerthread.send(s:string);
var i:integer;
    ok:boolean;
begin
  ok:=false;
  for i:=low(connectsocket) to high(connectsocket) do begin
    if connectsocket[i]<>0 then begin
      ok:=true;
      if winsock.send(connectsocket[i],s[1],length(s),0)<>socket_error then
        sendtext('Message sent',1)
      else
        sendtext('Fehler beim Senden',1);
    end;
  end;
  if not ok then sendtext('nicht verbunden',1);
end;
procedure TServerThread.initSocket(ip,port:integer);
var addr:sockaddr_in;
    ok:boolean;
begin
  if acceptsocket<>0 then exit;
  ok:=false;
  acceptSocket:=socket(af_inet,SOCK_STREAM,IPPROTO_TCP);
  if acceptsocket=invalid_socket then
    sendtext('Fehler beim Initialisieren von AcceptSocket',1)
  else begin

      addr.sin_family:=af_inet;
      addr.sin_port:=port;
      addr.sin_addr.S_addr:=ip;
      if bind(acceptSocket,addr,sizeof(addr))=socket_error then
        sendtext('Fehler beim Binden von AcceptSocket',1)
      else begin
        if listen(acceptSocket,1)=socket_error then
          sendtext('Fehler beim Einschalten von Listen',1)
        else begin
          if wsaasyncselect(acceptSocket,handle,WM_user,FD_ALL)=socket_error then
            sendtext('Fehler beim Initialisieren des Events',1)
          else begin
            ok:=true;
            sendtext('Server gestartet',1);
          end;
        end;
      end;

  end;
  if not ok then begin
    winsock.closesocket(acceptsocket);
    acceptsocket:=0;
  end;
  aktshape;
  afterinit;
end;
procedure TServerThread.Execute;
begin
  setlength(connectsocket,0);
  acceptsocket:=0;
  handle:=allocatehwnd(wndproc);
  postmessage(owner,wmhandle,handle,0);
  aktshape;
  run;
  postmessage(owner,WM_close,0,0);
  deallocatehwnd(handle);
end;

procedure TServerThread.insertsocket(asocket:integer);
var i:integer;
    ok:boolean;
begin
  ok:=false;
  for i:=low(connectsocket) to high(connectsocket) do begin
    if (connectsocket[i]=0)or(connectsocket[i]=asocket) then begin
      connectsocket[i]:=asocket;
      ok:=true;
      break;
    end;
  end;
  if not ok then begin
    i:=length(connectsocket);
    setlength(connectsocket,i+1);
    connectsocket[i]:=asocket;
  end;
  afterconnect(i);
end;
procedure TServerthread.deletesocket(asocket:integer);
var i:integer;
begin
  for i:=low(connectsocket) to high(connectsocket) do
    if connectsocket[i]=asocket then connectsocket[i]:=0;
end;
function TServerThread.IsconnectSocket(asocket:integer):boolean;
var i:integer;
begin
  result:=false;
  for i:=low(connectsocket) to high(connectsocket) do
    result:=result or (connectsocket[i]=asocket);
end;
function TServerthread.Socketcount:integer;
var i:integer;
begin
  result:=0;
  for i:=low(connectsocket) to high(connectsocket) do
    if connectsocket[i]<>0 then inc(result);
end;

procedure TserverThread.afterinit;
var h:Phostent;
    l:integer;
    laddr:sockaddr_in;
    addr:^PInAddr;
    addr_s:string;
begin
  if acceptsocket=0 then exit;
  l:=sizeof(laddr);
  getsockname(acceptsocket,laddr,l);
  h:=gethostbyname(nil);
  Addr:=Pointer(h^.h_addr_list);
  if (Addr<>nil) AND (Addr^<>nil) then addr_s:=(inet_ntoa(Addr^^));
  sendtext('Connection Parameters',0);
  sendtext('  SocketIP (bind to): '+inet_ntoa(laddr.sin_addr),0);
  sendtext('  LocalIP: '+addr_s,0);
  sendtext('  LocalPort: '+inttostr(ntohs(laddr.sin_port)),0);
  sendtext('  LocalHost: '+h^.h_name,0);

end;
procedure TServerThread.afterconnect(nr:integer);
var l:integer;
    raddr:sockaddr_in;
begin
  if connectsocket[nr]=0 then exit;
  l:=sizeof(raddr);
  getpeername(connectsocket[nr],raddr,l);

  sendtext('Connection Parameters',0);
  sendtext('  RemoteIP: '+inet_ntoa(raddr.sin_addr),0);
  sendtext('  RemotePort: '+inttostr(ntohs(raddr.sin_port)),0);

end;


end.
