unit U_main;
{
Beispielprogram des Tutorials "Sockets mit WinAPI"
(c) Etienne Gasch 2007
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, winsock, U_serverform, U_clientform, XPMan;

const TM_Close=WM_User+10;

type
  TMainForm = class(TForm)
    BeendenButton: TButton;
    ServerButton: TButton;
    ClientButton: TButton;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BeendenButtonClick(Sender: TObject);
    procedure getClose(var msg:Tmessage);message TM_Close;
    procedure ServerButtonClick(Sender: TObject);
    procedure ClientButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
    wsa:wsadata;
    doClose:boolean;
    Server:array of TServerform;
    client:array of TClientform;
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  doclose:=false;
  wsastartup($0101,wsa);
  setlength(server,0);
  setlength(client,0);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var i,z:integer;
    ok:boolean;
begin
  doclose:=true;
  for i:=low(server) to high(server) do if server[i]<>nil then begin
    postmessage(server[i].handle,wm_close,0,0);
  end;
  for i:=low(client) to high(client) do if client[i]<>nil then begin
    postmessage(client[i].handle,wm_close,0,0);
  end;
  z:=0;
  repeat
    sleep(0);
    application.ProcessMessages;
    inc(z);
    ok:=true;
    for i:=low(server) to high(server) do ok:=ok and (server[i]=nil);
    for i:=low(client) to high(client) do ok:=ok and (client[i]=nil);
  until (ok) or (z>1000);
  finalize(client);
  finalize(server);
  wsacleanup;
end;

procedure TMainForm.BeendenButtonClick(Sender: TObject);
begin
  if doclose then exit;
  close;
end;

procedure TMainForm.getClose(var msg:Tmessage);
begin
  case msg.LParam of
    0: freeandnil(server[msg.wparam-1]);
    1: freeandnil(client[msg.wparam-1]);
  end;
end;

procedure TMainForm.ServerButtonClick(Sender: TObject);
var i:integer;
    ok:boolean;
begin
  if doclose then exit;
  ok:=false;
  for i:=low(server) to high(server) do begin
    if server[i]=nil then begin
      server[i]:=TServerform.create(handle,i+1);
      server[i].show;
      ok:=true;
      break;
    end;
  end;
  if not ok then begin
    i:=length(server);
    setlength(server,i+1);
    server[i]:=TServerform.create(handle,i+1);
    server[i].Show;
  end;
end;

procedure TMainForm.ClientButtonClick(Sender: TObject);
var i:integer;
    ok:boolean;
begin
  if doclose then exit;

  ok:=false;
  for i:=low(client) to high(client) do begin
    if client[i]=nil then begin
      client[i]:=Tclientform.create(handle,i+1);
      client[i].show;
      ok:=true;
      break;
    end;
  end;
  if not ok then begin
    i:=length(client);
    setlength(client,i+1);
    client[i]:=TClientform.create(handle,i+1);
    client[i].show;
  end;
end;


end.
